import { AbstractOutputComponent, AbstractOutputProps, AbstractOutputState } from './abstract-output-component';
import * as React from 'react';
import { ResponseStatus } from 'tsp-typescript-client/lib/models/response/responses';
export declare type AbstractTreeOutputState = AbstractOutputState & {
    showTree: boolean;
};
export declare abstract class AbstractTreeOutputComponent<P extends AbstractOutputProps, S extends AbstractTreeOutputState> extends AbstractOutputComponent<P, S> {
    private readonly DEFAULT_Y_AXIS_WIDTH;
    private readonly DEFAULT_SASH_WIDTH;
    private sashDownX;
    private sashDownOffset;
    constructor(props: P);
    renderMainArea(): React.ReactNode;
    private onSashDown;
    private onSashMove;
    private onSashUp;
    treeRef: React.RefObject<HTMLDivElement>;
    abstract renderTree(): React.ReactNode;
    abstract renderYAxis(): React.ReactNode;
    abstract renderChart(): React.ReactNode;
    abstract fetchTree(): Promise<ResponseStatus>;
    abstract resultsAreEmpty(): boolean;
    protected waitAnalysisCompletion(): Promise<void>;
    componentWillUnmount(): void;
    protected getYAxisWidth(): number;
    protected getSashWidth(): number;
    getTreeWidth(): number;
    getChartWidth(): number;
}
//# sourceMappingURL=abstract-tree-output-component.d.ts.map