"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TimegraphOutputComponent = void 0;
const React = __importStar(require("react"));
const time_graph_state_1 = require("timeline-chart/lib/components/time-graph-state");
const time_graph_chart_1 = require("timeline-chart/lib/layer/time-graph-chart");
const time_graph_chart_arrows_1 = require("timeline-chart/lib/layer/time-graph-chart-arrows");
const time_graph_range_events_layer_1 = require("timeline-chart/lib/layer/time-graph-range-events-layer");
const time_graph_chart_cursors_1 = require("timeline-chart/lib/layer/time-graph-chart-cursors");
const time_graph_markers_chart_cursors_1 = require("timeline-chart/lib/layer/time-graph-markers-chart-cursors");
const time_graph_chart_grid_1 = require("timeline-chart/lib/layer/time-graph-chart-grid");
const time_graph_chart_selection_range_1 = require("timeline-chart/lib/layer/time-graph-chart-selection-range");
const time_graph_vertical_scrollbar_1 = require("timeline-chart/lib/layer/time-graph-vertical-scrollbar");
const time_graph_row_controller_1 = require("timeline-chart/lib/time-graph-row-controller");
const query_helper_1 = require("tsp-typescript-client/lib/models/query/query-helper");
const responses_1 = require("tsp-typescript-client/lib/models/response/responses");
const signal_manager_1 = require("traceviewer-base/lib/signals/signal-manager");
const abstract_tree_output_component_1 = require("./abstract-tree-output-component");
const style_properties_1 = require("./data-providers/style-properties");
const style_provider_1 = require("./data-providers/style-provider");
const tsp_data_provider_1 = require("./data-providers/tsp-data-provider");
const timegraph_container_component_1 = require("./utils/timegraph-container-component");
const entry_tree_1 = require("./utils/filter-tree/entry-tree");
const utils_1 = require("./utils/filter-tree/utils");
const value_hash_1 = __importDefault(require("traceviewer-base/lib/utils/value-hash"));
const time_graph_annotation_1 = require("timeline-chart/lib/components/time-graph-annotation");
const lodash_1 = require("lodash");
const convert_color_string_to_hex_1 = require("traceviewer-base/lib/utils/convert-color-string-to-hex");
const free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const TextField_1 = __importDefault(require("@mui/material/TextField"));
const InputAdornment_1 = __importDefault(require("@mui/material/InputAdornment"));
const lodash_2 = require("lodash");
require("../../style/react-contextify.css");
const react_contexify_1 = require("react-contexify");
const context_menu_item_clicked_signal_payload_1 = require("traceviewer-base/lib/signals/context-menu-item-clicked-signal-payload");
const row_selections_changed_signal_payload_1 = require("traceviewer-base/lib/signals/row-selections-changed-signal-payload");
const COARSE_RESOLUTION_FACTOR = 8; // resolution factor to use for first (coarse) update
const MENU_ID = 'timegraph.menuId-';
class TimegraphOutputComponent extends abstract_tree_output_component_1.AbstractTreeOutputComponent {
    constructor(props) {
        var _a, _b;
        super(props);
        this.totalHeight = 0;
        this.styleMap = new Map();
        this.selectedMarkerCategories = undefined;
        this.onSelectionChanged = (payload) => this.doHandleSelectionChangedSignal(payload);
        this.onOutputDataChanged = (outputs) => this.doHandleOutputDataChangedSignal(outputs);
        this.onContextMenuContributed = (payload) => this.doHandleContextMenuContributed(payload);
        this._debouncedUpdateSearch = (0, lodash_2.debounce)(() => this.updateSearchFilter(), 500);
        this._debouncedUpdateChart = (0, lodash_2.debounce)(() => {
            this.chartLayer.updateChart();
        }, 500);
        this.handleItemClick = (params) => {
            const props = {
                selectedRows: this.getEntryModelsForRowIds(this.state.multiSelectedRows)
            };
            const signalPayload = new context_menu_item_clicked_signal_payload_1.ContextMenuItemClickedSignalPayload(this.props.outputDescriptor.id, params.data.itemId, props, params.data.parentMenuId);
            (0, signal_manager_1.signalManager)().fireContextMenuItemClicked(signalPayload);
        };
        this.getEntryModelsForRowIds = (ids
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        ) => {
            if (!ids) {
                return [];
            }
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            const entryModels = [];
            for (const id of ids) {
                const element = this.state.timegraphTree.find(el => el.id === id);
                if (element) {
                    entryModels.push({ id: element.id, parentId: element.parentId, metadata: element.metadata });
                }
            }
            return entryModels;
        };
        this.doHandleOutputDataChangedSignal = async (outputs) => {
            const desc = outputs.find(descriptor => descriptor.id === this.props.outputDescriptor.id);
            if (desc !== undefined) {
                await this.fetchTree();
                this._debouncedUpdateChart();
            }
        };
        this.onThemeChange = () => {
            // Simulate a click on the selected row when theme changes.
            // This changes the color of the selected row to new theme.
            const selectedRow = this.state.selectedRow;
            if (selectedRow) {
                this.onRowClick(selectedRow);
            }
        };
        /**
         *  This method is passed down all the way to TableCell component.
         *  It communicates a row-selection with the timeline-chart component.
         *  @param {number} id TreeNode id number
         */
        this.onRowClick = (id) => {
            var _a;
            const rowIndex = (0, utils_1.getIndexOfNode)(id, (0, utils_1.listToTree)(this.state.timegraphTree, this.state.columns), this.state.collapsedNodes);
            this.chartLayer.selectAndReveal(rowIndex);
            if (((_a = this.rowController.selectedRow) === null || _a === void 0 ? void 0 : _a.id) !== id) {
                // This highlights the left side if the row is loading.
                this.setState({ selectedRow: id });
            }
            // Regular clicking on a row should clear the multi selected rows to only include the clicked row
            this.setState({ multiSelectedRows: [id] });
        };
        this.onMultipleRowClick = (id, isShiftClicked) => {
            const tree = (0, utils_1.listToTree)(this.state.timegraphTree, this.state.columns);
            const rowIndex = (0, utils_1.getIndexOfNode)(id, tree, this.state.collapsedNodes);
            if (isShiftClicked) {
                // Perform shift action based on selectedRow value
                if (this.state.selectedRow !== undefined) {
                    const treeNodeIds = (0, utils_1.getAllExpandedNodeIds)(tree, this.state.collapsedNodes);
                    const lastSelectedRowIndex = (0, utils_1.getIndexOfNode)(this.state.selectedRow, tree, this.state.collapsedNodes);
                    this.handleShiftClick(rowIndex, lastSelectedRowIndex, treeNodeIds);
                }
                else {
                    // Do not have a previous selection therefore treat this as a normal row click
                    this.onRowClick(id);
                }
            }
            else {
                const rows = this.state.multiSelectedRows ? this.state.multiSelectedRows.slice() : [];
                // This indicates that the row is being deselected
                if (rows.includes(id)) {
                    const index = rows.indexOf(id);
                    /**
                     *  It is possible for the entry being deselected to be selectedRow.
                     *  In this case we have to update the selectedRow state to point to another row
                     *  We will try to set this to previously selected row that is part of the multi-selection, otherwise it should be set to undefined
                     */
                    if (id === this.state.selectedRow) {
                        const prevRowId = rows.at(index - 1);
                        if (prevRowId && prevRowId !== id) {
                            const prevRowIndex = (0, utils_1.getIndexOfNode)(prevRowId, tree, this.state.collapsedNodes);
                            this.chartLayer.selectAndReveal(prevRowIndex);
                        }
                        else {
                            this.setState({ selectedRow: undefined });
                            this.chartLayer.selectRow(undefined);
                        }
                    }
                    rows.splice(index, 1);
                }
                else {
                    // No selectedRow - delegate to onRowClick as it is a first selection
                    if (this.state.selectedRow === undefined) {
                        this.onRowClick(id);
                        return;
                    }
                    rows === null || rows === void 0 ? void 0 : rows.push(id);
                }
                this.setState({ multiSelectedRows: rows });
            }
        };
        this.onMarkerRowClick = (id) => {
            const rowIndex = (0, utils_1.getIndexOfNode)(id, (0, utils_1.listToTree)(this.state.markerCategoryEntries, this.state.columns), this.state.collapsedNodes);
            this.markersChartLayer.selectAndReveal(rowIndex);
        };
        this.onSelectionChange = (row) => {
            this.setState({ selectedRow: row.id });
        };
        this.onMarkerSelectionChange = (row) => {
            this.setState({ selectedMarkerRow: row.id });
        };
        this.handleShiftClick = (currentIndex, lastSelectedRowIndex, treeNodeIds) => {
            const shiftClickedRows = [];
            let startIndex = 0;
            let endIndex = 0;
            if (lastSelectedRowIndex < currentIndex) {
                startIndex = lastSelectedRowIndex;
                endIndex = currentIndex;
            }
            else {
                startIndex = currentIndex;
                endIndex = lastSelectedRowIndex;
            }
            if (startIndex < 0 || startIndex >= treeNodeIds.length || endIndex >= treeNodeIds.length) {
                return;
            }
            for (let i = startIndex; i <= endIndex; i++) {
                const nodeId = treeNodeIds.at(i);
                if (nodeId) {
                    shiftClickedRows.push(nodeId);
                }
            }
            this.setState({ multiSelectedRows: shiftClickedRows });
        };
        this.state = {
            outputStatus: responses_1.ResponseStatus.RUNNING,
            timegraphTree: [],
            markerCategoryEntries: [],
            markerLayerData: undefined,
            collapsedNodes: (0, utils_1.validateNumArray)((_a = this.props.persistChartState) === null || _a === void 0 ? void 0 : _a.collapsedNodes)
                ? this.props.persistChartState.collapsedNodes
                : [],
            selectedRow: undefined,
            multiSelectedRows: [],
            selectedMarkerRow: undefined,
            columns: [],
            collapsedMarkerNodes: (0, utils_1.validateNumArray)((_b = this.props.persistChartState) === null || _b === void 0 ? void 0 : _b.collapsedMarkerNodes)
                ? this.props.persistChartState.collapsedMarkerNodes
                : [],
            dataRows: [],
            showTree: true,
            searchString: ''
        };
        this.selectedMarkerCategories = this.props.markerCategories;
        this.onToggleCollapse = this.onToggleCollapse.bind(this);
        this.onMarkerCategoryRowClose = this.onMarkerCategoryRowClose.bind(this);
        this.onToggleAnnotationCollapse = this.onToggleAnnotationCollapse.bind(this);
        this.tspDataProvider = new tsp_data_provider_1.TspDataProvider(this.props.tspClient, this.props.traceId, this.props.outputDescriptor.id);
        this.styleProvider = new style_provider_1.StyleProvider(this.props.outputDescriptor.id, this.props.traceId, this.props.tspClient);
        this.rowController = new time_graph_row_controller_1.TimeGraphRowController(this.props.style.rowHeight, this.totalHeight);
        this.markerRowController = new time_graph_row_controller_1.TimeGraphRowController(this.props.style.rowHeight, this.totalHeight);
        this.horizontalContainer = React.createRef();
        this.timeGraphTreeRef = React.createRef();
        this.markerTreeRef = React.createRef();
        this.containerRef = React.createRef();
        this.handleSearchChange = this.handleSearchChange.bind(this);
        this.clearSearchBox = this.clearSearchBox.bind(this);
        this.onMultipleRowClick = this.onMultipleRowClick.bind(this);
        this.onCtxMenu = this.onCtxMenu.bind(this);
        const providers = {
            rowProvider: () => this.getTimegraphRowIds(),
            /**
             * @param range requested time range
             * @param resolution requested time interval between samples
             * @returns row models with the actual range and resolution
             */
            dataProvider: async (range, resolution, fetchArrows, rowIds, 
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            additionalProperties) => this.fetchTimegraphData(range, resolution, fetchArrows, rowIds, additionalProperties),
            stateStyleProvider: (state) => this.getStateStyle(state),
            rowAnnotationStyleProvider: (annotation) => this.getAnnotationStyle(annotation),
            rowStyleProvider: (row) => this.getRowStyle(row)
        };
        const markersProvider = {
            rowProvider: () => this.getMarkersRowIds(),
            dataProvider: async (range, resolution) => this.fetchMarkersData(range, resolution),
            stateStyleProvider: (state) => this.getMarkerStateStyle(state),
            rowStyleProvider: (row) => this.getRowStyle(row)
        };
        this.rangeEventsLayer = new time_graph_range_events_layer_1.TimeGraphRangeEventsLayer('timeGraphRangeEvents', providers);
        this.chartLayer = new time_graph_chart_1.TimeGraphChart('timeGraphChart', providers, this.rowController, COARSE_RESOLUTION_FACTOR);
        this.arrowLayer = new time_graph_chart_arrows_1.TimeGraphChartArrows('timeGraphChartArrows', this.rowController);
        this.vscrollLayer = new time_graph_vertical_scrollbar_1.TimeGraphVerticalScrollbar('timeGraphVerticalScrollbar', this.rowController);
        this.chartCursors = new time_graph_chart_cursors_1.TimeGraphChartCursors('chart-cursors', this.chartLayer, this.rowController, {
            color: this.props.style.cursorColor
        });
        this.rowController.onSelectedRowChangedHandler(this.onSelectionChange);
        this.markerRowController.onSelectedRowChangedHandler(this.onMarkerSelectionChange);
        this.rowController.onVerticalOffsetChangedHandler(() => {
            if (this.timeGraphTreeRef.current) {
                this.timeGraphTreeRef.current.scrollTop = this.rowController.verticalOffset;
            }
        });
        this.markersChartLayer = new time_graph_chart_1.TimeGraphChart('timeGraphChart', markersProvider, this.markerRowController);
        this.markerChartCursors = new time_graph_markers_chart_cursors_1.TimeGraphMarkersChartCursors('chart-cursors-new', this.markersChartLayer, this.markerRowController, { color: this.props.style.cursorColor });
        this.chartLayer.onSelectedStateChanged(model => {
            this.pendingSelection = undefined;
            if (model) {
                this.selectedElement = this.chartLayer.getStateById(model.id);
            }
            else {
                this.selectedElement = undefined;
            }
            this.onElementSelected(this.selectedElement);
        });
        this.chartLayer.registerMouseInteractions({
            mouseover: el => {
                var _a;
                (_a = this.props.tooltipComponent) === null || _a === void 0 ? void 0 : _a.setElement(el, () => this.fetchTooltip(el));
            },
            mouseout: () => {
                var _a;
                (_a = this.props.tooltipComponent) === null || _a === void 0 ? void 0 : _a.setElement(undefined);
            },
            click: (el, ev, clickCount) => {
                if (clickCount === 2) {
                    const start = el.model.range.start;
                    const end = el.model.range.end;
                    if (start !== end) {
                        this.props.unitController.viewRange = {
                            start,
                            end
                        };
                    }
                }
            }
        });
        this.markersChartLayer.registerMouseInteractions({
            click: el => {
                if (el instanceof time_graph_state_1.TimeGraphStateComponent) {
                    if (el.model.range.start !== undefined && el.model.range.end !== undefined) {
                        this.props.unitController.selectionRange = {
                            start: el.model.range.start,
                            end: el.model.range.end
                        };
                    }
                }
            }
        });
        this.addPinViewOptions(() => ({
            collapsedNodes: this.state.collapsedNodes,
            collapsedMarkerNodes: this.state.collapsedMarkerNodes
        }));
    }
    synchronizeTreeScroll() {
        if (this.timeGraphTreeRef.current) {
            this.rowController.verticalOffset = this.timeGraphTreeRef.current.scrollTop;
        }
    }
    async componentDidMount() {
        this.setState({
            styleModel: await this.styleProvider.getStyleModel()
        });
        this.waitAnalysisCompletion();
        this.subscribeToEvents();
    }
    componentWillUnmount() {
        var _a;
        super.componentWillUnmount();
        this.unsubscribeToEvents();
        (_a = this.containerRef.current) === null || _a === void 0 ? void 0 : _a.destroyContainer();
    }
    subscribeToEvents() {
        (0, signal_manager_1.signalManager)().on(signal_manager_1.Signals.CONTRIBUTE_CONTEXT_MENU, this.onContextMenuContributed);
        (0, signal_manager_1.signalManager)().on(signal_manager_1.Signals.OUTPUT_DATA_CHANGED, this.onOutputDataChanged);
        (0, signal_manager_1.signalManager)().on(signal_manager_1.Signals.THEME_CHANGED, this.onThemeChange);
        (0, signal_manager_1.signalManager)().on(signal_manager_1.Signals.SELECTION_CHANGED, this.onSelectionChanged);
    }
    unsubscribeToEvents() {
        (0, signal_manager_1.signalManager)().off(signal_manager_1.Signals.CONTRIBUTE_CONTEXT_MENU, this.onContextMenuContributed);
        (0, signal_manager_1.signalManager)().off(signal_manager_1.Signals.OUTPUT_DATA_CHANGED, this.onOutputDataChanged);
        (0, signal_manager_1.signalManager)().off(signal_manager_1.Signals.THEME_CHANGED, this.onThemeChange);
        (0, signal_manager_1.signalManager)().off(signal_manager_1.Signals.SELECTION_CHANGED, this.onSelectionChanged);
    }
    async fetchTree() {
        const parameters = query_helper_1.QueryHelper.timeRangeQuery(this.props.range.getStart(), this.props.range.getEnd());
        const tspClientResponse = await this.props.tspClient.fetchTimeGraphTree(this.props.traceId, this.props.outputDescriptor.id, parameters);
        const treeResponse = tspClientResponse.getModel();
        if (tspClientResponse.isOk() && treeResponse) {
            if (treeResponse.model) {
                const headers = treeResponse.model.headers;
                const columns = [];
                if (headers && headers.length > 0) {
                    headers.forEach(header => {
                        columns.push({ title: header.name, sortable: true, resizable: true, tooltip: header.tooltip });
                    });
                }
                else {
                    columns.push({ title: 'Name', sortable: true });
                }
                this.setState({
                    outputStatus: treeResponse.status,
                    timegraphTree: treeResponse.model.entries,
                    columns
                }, this.updateTotalHeight);
            }
            else {
                this.setState({
                    outputStatus: treeResponse.status
                });
            }
            return treeResponse.status;
        }
        this.setState({
            outputStatus: responses_1.ResponseStatus.FAILED
        });
        return responses_1.ResponseStatus.FAILED;
    }
    async componentDidUpdate(prevProps, prevState) {
        if (prevState.outputStatus === responses_1.ResponseStatus.RUNNING ||
            !(0, lodash_1.isEqual)(this.state.collapsedNodes, prevState.collapsedNodes) ||
            !(0, lodash_1.isEqual)(prevProps.markerCategories, this.props.markerCategories) ||
            prevProps.markerSetId !== this.props.markerSetId) {
            this.selectedMarkerCategories = this.props.markerCategories;
            if (this.state.searchString && this.state.searchString.length > 0) {
                this._debouncedUpdateSearch();
            }
            else {
                this.chartLayer.updateChart();
            }
            this.markersChartLayer.updateChart();
            this.arrowLayer.update();
            this.rangeEventsLayer.update();
        }
        if (!(0, lodash_1.isEqual)(this.state.markerCategoryEntries, prevState.markerCategoryEntries) ||
            !(0, lodash_1.isEqual)(this.state.collapsedMarkerNodes, prevState.collapsedMarkerNodes) ||
            !(0, lodash_1.isEqual)(this.state.markerLayerData, prevState.markerLayerData)) {
            this.markersChartLayer.updateChart();
        }
        if (!(0, lodash_1.isEqual)(this.state.searchString, prevState.searchString)) {
            this._debouncedUpdateSearch();
        }
        if (!(0, lodash_1.isEqual)(this.state.multiSelectedRows, prevState.multiSelectedRows)) {
            const signalPayload = new row_selections_changed_signal_payload_1.RowSelectionsChangedSignalPayload(this.props.traceId, this.props.outputDescriptor.id, this.getEntryModelsForRowIds(this.state.multiSelectedRows));
            (0, signal_manager_1.signalManager)().fireRowSelectionsChanged(signalPayload);
        }
    }
    async updateSearchFilter() {
        if (this.state.searchString && this.state.searchString.length > 0) {
            const filterExpressionsMap = {};
            filterExpressionsMap[1] = [this.state.searchString];
            this.chartLayer.updateChart(filterExpressionsMap);
        }
        else {
            this.chartLayer.updateChart();
        }
    }
    onToggleCollapse(id) {
        let newList = [...this.state.collapsedNodes];
        const exist = this.state.collapsedNodes.find(expandId => expandId === id);
        if (exist !== undefined) {
            newList = newList.filter(collapsed => id !== collapsed);
        }
        else {
            newList = newList.concat(id);
        }
        this.setState({ collapsedNodes: newList }, this.updateTotalHeight);
    }
    onToggleAnnotationCollapse() {
        if (this.state.collapsedMarkerNodes.length === 0) {
            const annotationNodes = this.state.markerCategoryEntries.map(annotation => annotation.id);
            this.setState({ collapsedMarkerNodes: annotationNodes });
        }
        else {
            this.setState({ collapsedMarkerNodes: [] });
        }
    }
    onMarkerCategoryRowClose(id) {
        const annotation = this.state.markerCategoryEntries.find(entry => entry.id === id);
        if (annotation && this.selectedMarkerCategories) {
            const annotationLabel = annotation.labels[0];
            this.setState({
                markerCategoryEntries: this.state.markerCategoryEntries.filter(item => item !== annotation)
            });
            this.selectedMarkerCategories = this.selectedMarkerCategories.filter(item => item !== annotationLabel);
            const markerLayerData = this.state.markerLayerData;
            if (markerLayerData) {
                markerLayerData.rows = markerLayerData.rows.filter(row => row.id !== id);
                this.setState({
                    markerLayerData
                });
            }
            (0, signal_manager_1.signalManager)().fireMarkerCategoryClosedSignal({
                traceViewerId: this.props.traceId,
                markerCategory: annotationLabel
            });
        }
    }
    updateTotalHeight() {
        const visibleEntries = [...this.state.timegraphTree].filter(entry => this.isVisible(entry));
        this.totalHeight = visibleEntries.length * this.props.style.rowHeight;
        this.rowController.totalHeight = this.totalHeight;
    }
    isVisible(entry) {
        let parentId = entry.parentId;
        while (parentId !== undefined && parentId !== -1) {
            if (this.state.collapsedNodes.includes(parentId)) {
                return false;
            }
            const parent = this.state.timegraphTree.find(e => e.id === parentId);
            parentId = parent ? parent.parentId : undefined;
        }
        return true;
    }
    doHandleSelectionChangedSignal(payload) {
        const startTimestamp = payload['startTimestamp'];
        const endTimestamp = payload['endTimestamp'];
        if (startTimestamp !== undefined && endTimestamp !== undefined) {
            const foundElement = this.findElement(payload);
            // Scroll vertically
            if (foundElement) {
                // Expand parent
                if (this.expandParents(foundElement)) {
                    this.selectAndReveal(foundElement);
                }
                else {
                    this.pendingSelection = foundElement;
                }
            }
            this.chartCursors.maybeCenterCursor();
        }
    }
    /**
     * For each line in the tree (this.state.timegraphTree), parse the metadata and try to find
     * matches with the key / values pairs of the selected event.
     * It counts the amount of metadata matches and returns the TimeGraphEntry with the greatest amount,
     * which is the most likely result.
     *
     * @params payload
     *      Object with information about the selected event.
     * @return
     *      Correspondent TimeGraphEntry from this.state.timegraphTree
     */
    findElement(payload) {
        let element = undefined;
        let max = 0;
        if (payload && payload.load) {
            this.state.timegraphTree.forEach(el => {
                if (el.metadata) {
                    let cnt = 0;
                    Object.entries(el.metadata).forEach(([key, values]) => {
                        if (typeof payload.load !== 'string') {
                            const val = payload.load[key];
                            if (val !== undefined) {
                                const num = Number(val);
                                // at least one value in array needs to match
                                const result = values.find((value) => (num !== undefined && num === value) || val === value);
                                if (result !== undefined) {
                                    cnt++;
                                }
                            }
                        }
                    });
                    if (cnt > max) {
                        max = cnt;
                        element = el;
                    }
                }
            });
        }
        return element;
    }
    getMarkersLayerHeight() {
        const rowHeight = 20;
        const scrollbarHeight = 10;
        return this.state.markerCategoryEntries.length <= 1
            ? 0
            : this.state.collapsedMarkerNodes.length
                ? rowHeight
                : this.state.markerCategoryEntries.length * rowHeight + scrollbarHeight;
    }
    renderTree() {
        var _a, _b;
        // TODO Show header, when we can have entries in-line with timeline-chart
        return (React.createElement(React.Fragment, null,
            React.createElement("div", { ref: this.timeGraphTreeRef, className: "scrollable", onScroll: () => this.synchronizeTreeScroll(), style: {
                    height: parseInt(this.props.style.height.toString()) -
                        this.getMarkersLayerHeight() -
                        ((_b = (_a = document.getElementById(this.props.traceId + this.props.outputDescriptor.id + 'searchBar')) === null || _a === void 0 ? void 0 : _a.offsetHeight) !== null && _b !== void 0 ? _b : 0)
                }, tabIndex: 0 },
                this.renderContextMenu(),
                React.createElement(entry_tree_1.EntryTree, { collapsedNodes: this.state.collapsedNodes, showFilter: false, entries: this.state.timegraphTree, showCheckboxes: false, onToggleCollapse: this.onToggleCollapse, onRowClick: this.onRowClick, onMultipleRowClick: this.onMultipleRowClick, selectedRow: this.state.selectedRow, multiSelectedRows: this.state.multiSelectedRows, showHeader: false, onContextMenu: this.onCtxMenu, className: "table-tree timegraph-tree" })),
            React.createElement("div", { ref: this.markerTreeRef, className: "scrollable", style: { height: this.getMarkersLayerHeight() } },
                React.createElement(entry_tree_1.EntryTree, { collapsedNodes: this.state.collapsedMarkerNodes, showFilter: false, entries: this.state.markerCategoryEntries, showCheckboxes: false, showCloseIcons: true, onRowClick: this.onMarkerRowClick, selectedRow: this.state.selectedMarkerRow, onToggleCollapse: this.onToggleAnnotationCollapse, onClose: this.onMarkerCategoryRowClose, showHeader: false, className: "table-tree timegraph-tree" }))));
    }
    onCtxMenu(event, id) {
        var _a;
        event.preventDefault();
        event.stopPropagation();
        if (!this.state.menuItems ||
            (this.state.menuItems.items.length <= 0 && this.state.menuItems.submenus.length <= 0)) {
            return;
        }
        // If the id that the context menu was triggered from is not in multi-selected-rows, we treat this as a row click
        if (!((_a = this.state.multiSelectedRows) === null || _a === void 0 ? void 0 : _a.includes(id))) {
            this.onRowClick(id);
        }
        const refNode = this.treeRef.current;
        let calculatedX = 0;
        let calculatedY = 0;
        if (refNode) {
            calculatedX = event.clientX - refNode.getBoundingClientRect().left;
            calculatedY = event.clientY - refNode.getBoundingClientRect().top;
        }
        const { show } = (0, react_contexify_1.useContextMenu)({
            id: MENU_ID + this.props.outputDescriptor.id
        });
        show(event, {
            props: {},
            position: { x: calculatedX, y: calculatedY }
        });
    }
    renderContextMenu() {
        if (!this.state.menuItems ||
            (this.state.menuItems.items.length <= 0 && this.state.menuItems.submenus.length <= 0)) {
            return React.createElement(React.Fragment, null);
        }
        return (React.createElement(React.Fragment, null,
            React.createElement(react_contexify_1.Menu, { id: MENU_ID + this.props.outputDescriptor.id, theme: this.props.backgroundTheme, animation: 'fade' },
                this.renderSubMenu(this.state.menuItems.submenus),
                this.state.menuItems.submenus.length > 0 && React.createElement(react_contexify_1.Separator, null),
                this.renderItems(this.state.menuItems.items))));
    }
    renderSubMenu(submenus) {
        return (React.createElement(React.Fragment, null, submenus && submenus.length > 0 ? (submenus.map(menu => (React.createElement(react_contexify_1.Submenu, { label: menu.label, id: menu.id, key: menu.id },
            menu.submenu && this.renderSubMenu([menu.submenu]),
            this.renderItems(menu.items))))) : (React.createElement(React.Fragment, null))));
    }
    renderItems(items) {
        return (React.createElement(React.Fragment, null, items && items.length > 0 ? (items.map(item => (React.createElement(react_contexify_1.Item, { key: item.id, id: item.id, onClick: this.handleItemClick, data: {
                itemId: item.id,
                itemLabel: item.label,
                parentMenuId: item.parentMenuId
            } }, item.label)))) : (React.createElement(React.Fragment, null))));
    }
    renderYAxis() {
        return undefined;
    }
    renderChart() {
        return (React.createElement(React.Fragment, null, this.state.outputStatus === responses_1.ResponseStatus.COMPLETED ? (React.createElement("div", { id: "timegraph-main", className: "ps__child--consume", onWheel: ev => {
                ev.preventDefault();
                ev.stopPropagation();
            }, style: { height: this.props.style.height } }, this.renderTimeGraphContent())) : (React.createElement("div", { className: "analysis-running" },
            React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faSpinner, spin: true, style: { marginRight: '5px' } }),
            'Analysis running'))));
    }
    resultsAreEmpty() {
        return this.state.timegraphTree.length === 0;
    }
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    async fetchTooltip(element) {
        if (element instanceof time_graph_state_1.TimeGraphStateComponent) {
            const label = element.model.label ? element.model.label : '';
            const elementRange = element.model.range;
            const offset = this.props.viewRange.getOffset();
            let start;
            let end;
            if (this.props.unitController.numberTranslator) {
                start = this.props.unitController.numberTranslator(elementRange.start) + ' s';
                end = this.props.unitController.numberTranslator(elementRange.end) + ' s';
            }
            start = start ? start : (elementRange.start + (offset ? offset : BigInt(0))).toString() + ' ns';
            end = end ? end : (elementRange.end + (offset ? offset : BigInt(0))).toString() + ' ns';
            const duration = (elementRange.end - elementRange.start).toString() + ' ns';
            const tooltip = await this.tspDataProvider.fetchStateTooltip(element, this.props.viewRange);
            return this.filterTooltip(Object.assign({ Label: label, 'Start time': start, 'End time': end, Duration: duration, Row: element.row.model.name }, tooltip));
        }
        else if (element instanceof time_graph_annotation_1.TimeGraphAnnotationComponent) {
            const category = element.model.category ? element.model.category : 'Label';
            const label = element.model.label ? element.model.label : '';
            const elementRange = element.model.range;
            const offset = this.props.viewRange.getOffset();
            let start;
            let end;
            if (this.props.unitController.numberTranslator) {
                start = this.props.unitController.numberTranslator(elementRange.start) + ' s';
                end = this.props.unitController.numberTranslator(elementRange.end) + ' s';
            }
            start = start ? start : (elementRange.start + (offset ? offset : BigInt(0))).toString() + ' ns';
            end = end ? end : (elementRange.end + (offset ? offset : BigInt(0))).toString() + ' ns';
            const tooltip = await this.tspDataProvider.fetchAnnotationTooltip(element, this.props.viewRange);
            if (start === end) {
                return this.filterTooltip(Object.assign({ [category]: label, Timestamp: start, Row: element.row.model.name }, tooltip));
            }
            else {
                return this.filterTooltip(Object.assign({ [category]: label, 'Start time': start, 'End time': end, Row: element.row.model.name }, tooltip));
            }
        }
    }
    filterTooltip(fullTooltip) {
        Object.keys(fullTooltip).forEach(key => {
            // eslint-disable-next-line no-null/no-null
            if (fullTooltip[key] === null) {
                delete fullTooltip[key];
            }
        });
        return fullTooltip;
    }
    renderTimeGraphContent() {
        return (React.createElement("div", { id: "main-timegraph-content", ref: this.horizontalContainer, style: { height: this.props.style.height } },
            this.getChartContainer(),
            this.getMarkersContainer(),
            React.createElement("div", { id: this.props.traceId + this.props.outputDescriptor.id + 'searchBar', className: "timgraph-search-bar" },
                React.createElement(TextField_1.default, { InputProps: {
                        placeholder: 'Search',
                        startAdornment: (React.createElement(InputAdornment_1.default, { sx: {
                                color: 'var(--trace-viewer-ui-font-color0)'
                            }, position: "start" },
                            React.createElement("i", { className: "codicon codicon-search" }))),
                        className: 'timegraph-search-box',
                        endAdornment: (React.createElement(InputAdornment_1.default, { sx: {
                                color: 'var(--trace-viewer-ui-font-color0)'
                            }, position: "end" },
                            React.createElement("button", { className: "remove-search-button", onClick: this.clearSearchBox },
                                React.createElement("i", { className: "codicon codicon-close" }))))
                    }, value: this.state.searchString, onChange: this.handleSearchChange, onKeyDown: event => this.onKeyDown(event) }))));
    }
    onKeyDown(event) {
        event.stopPropagation();
    }
    handleSearchChange(event) {
        var _a;
        this.setState({ searchString: (_a = event.target.value) !== null && _a !== void 0 ? _a : '' });
    }
    clearSearchBox() {
        this.setState({ searchString: '' });
    }
    getMarkersContainer() {
        return (React.createElement(timegraph_container_component_1.ReactTimeGraphContainer, { options: {
                id: 'timegraph-chart-1',
                height: this.getMarkersLayerHeight(),
                width: this.getChartWidth(),
                backgroundColor: this.props.style.chartBackgroundColor,
                lineColor: this.props.style.lineColor,
                classNames: 'horizontal-canvas'
            }, addWidgetResizeHandler: this.props.addWidgetResizeHandler, removeWidgetResizeHandler: this.props.removeWidgetResizeHandler, unitController: this.props.unitController, id: "timegraph-chart-1", layers: [this.markersChartLayer, this.markerChartCursors] }));
    }
    getChartContainer() {
        var _a, _b;
        const grid = new time_graph_chart_grid_1.TimeGraphChartGrid('timeGraphGrid', this.props.style.rowHeight, this.props.backgroundTheme === 'light' ? 0xdddddd : 0x34383c);
        const selectionRange = new time_graph_chart_selection_range_1.TimeGraphChartSelectionRange('chart-selection-range', {
            color: this.props.style.cursorColor
        });
        return (React.createElement(timegraph_container_component_1.ReactTimeGraphContainer, { ref: this.containerRef, options: {
                id: this.props.traceId + this.props.outputDescriptor.id + 'focusContainer',
                height: parseInt(this.props.style.height.toString()) -
                    this.getMarkersLayerHeight() -
                    ((_b = (_a = document.getElementById(this.props.traceId + this.props.outputDescriptor.id + 'searchBar')) === null || _a === void 0 ? void 0 : _a.offsetHeight) !== null && _b !== void 0 ? _b : 0),
                width: this.getChartWidth(),
                backgroundColor: this.props.style.chartBackgroundColor,
                lineColor: this.props.backgroundTheme === 'light' ? 0xdddddd : 0x34383c,
                classNames: 'horizontal-canvas'
            }, addWidgetResizeHandler: this.props.addWidgetResizeHandler, removeWidgetResizeHandler: this.props.removeWidgetResizeHandler, unitController: this.props.unitController, id: this.props.traceId + this.props.outputDescriptor.id + 'focusContainer', layers: [
                grid,
                this.chartLayer,
                selectionRange,
                this.chartCursors,
                this.arrowLayer,
                this.rangeEventsLayer
            ] }));
    }
    setFocus() {
        var _a, _b;
        if (document.getElementById(this.props.traceId + this.props.outputDescriptor.id + 'focusContainer')) {
            (_a = document.getElementById(this.props.traceId + this.props.outputDescriptor.id + 'focusContainer')) === null || _a === void 0 ? void 0 : _a.focus();
        }
        else {
            (_b = document.getElementById(this.props.traceId + this.props.outputDescriptor.id)) === null || _b === void 0 ? void 0 : _b.focus();
        }
    }
    getVerticalScrollbar() {
        return (React.createElement(timegraph_container_component_1.ReactTimeGraphContainer, { id: "vscroll", options: {
                id: 'vscroll',
                width: 10,
                height: parseInt(this.props.style.height.toString()),
                backgroundColor: this.props.style.naviBackgroundColor
            }, addWidgetResizeHandler: this.props.addWidgetResizeHandler, removeWidgetResizeHandler: this.props.removeWidgetResizeHandler, unitController: this.props.unitController, layers: [this.vscrollLayer] }));
    }
    async onElementSelected(element) {
        let tooltipObject = undefined;
        if (element && this.props.viewRange) {
            tooltipObject = await this.fetchTooltip(element);
        }
        (0, signal_manager_1.signalManager)().fireItemPropertiesSignalUpdated(tooltipObject);
    }
    getTimegraphRowIds() {
        return {
            rowIds: (0, utils_1.getAllExpandedNodeIds)((0, utils_1.listToTree)(this.state.timegraphTree, this.state.columns), this.state.collapsedNodes)
        };
    }
    async fetchTimegraphData(range, resolution, fetchArrows, rowIds, 
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    additionalProperties) {
        if (document.getElementById(this.props.traceId + this.props.outputDescriptor.id + 'handleSpinner')) {
            // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
            document.getElementById(this.props.traceId + this.props.outputDescriptor.id + 'handleSpinner').style.visibility = 'visible';
        }
        const ids = rowIds ? rowIds : this.getTimegraphRowIds().rowIds;
        const { start, end } = range;
        const newRange = range;
        const nbTimes = Math.ceil(Number(end - start) / resolution) + 1;
        const timeGraphData = await this.tspDataProvider.getData(ids, this.state.timegraphTree, fetchArrows, this.props.range, newRange, nbTimes, this.props.markerCategories, this.props.markerSetId, additionalProperties);
        this.updateMarkersData(timeGraphData.rangeEvents, newRange, nbTimes);
        if (fetchArrows) {
            this.arrowLayer.addArrows(timeGraphData.arrows, this.getTimegraphRowIds().rowIds);
        }
        this.rangeEventsLayer.addRangeEvents(timeGraphData.rangeEvents);
        if (document.getElementById(this.props.traceId + this.props.outputDescriptor.id + 'handleSpinner')) {
            // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
            document.getElementById(this.props.traceId + this.props.outputDescriptor.id + 'handleSpinner').style.visibility = 'hidden';
        }
        this.setState({ dataRows: timeGraphData.rows });
        // Apply the pending selection here since the row provider had been called before this method.
        if (this.pendingSelection) {
            const foundElement = this.pendingSelection;
            this.pendingSelection = undefined;
            this.selectAndReveal(foundElement);
        }
        return {
            rows: timeGraphData ? timeGraphData.rows : [],
            range: newRange,
            resolution: resolution
        };
    }
    updateMarkersData(rangeEvents, newRange, newResolution) {
        const annotationEntries = [];
        const markers = new Map();
        const categories = [];
        const rows = [];
        const filteredEvents = rangeEvents.filter(event => { var _a; return (_a = this.selectedMarkerCategories) === null || _a === void 0 ? void 0 : _a.includes(event.category); });
        filteredEvents.forEach((event, idx) => {
            var _a;
            const categoryName = event.category;
            if (!markers.has(categoryName)) {
                markers.set(categoryName, []);
                categories.push(categoryName);
            }
            const rowId = categories.indexOf(categoryName) + 1;
            const states = markers.get(categoryName) || [];
            const state = {
                id: rowId + '-' + idx,
                range: {
                    start: event.range.start,
                    end: event.range.end
                },
                label: event.label,
                data: {
                    style: (_a = event.data) === null || _a === void 0 ? void 0 : _a.style,
                    annotation: event
                }
            };
            states.push(state);
        });
        if (markers.size > 0) {
            const defaultRow = {
                id: 0,
                name: '',
                range: {
                    start: this.props.viewRange.getStart(),
                    end: this.props.viewRange.getStart() + this.props.unitController.absoluteRange
                },
                states: [],
                annotations: [],
                prevPossibleState: BigInt(Number.MIN_SAFE_INTEGER),
                nextPossibleState: BigInt(Number.MAX_SAFE_INTEGER)
            };
            rows.push(defaultRow);
            annotationEntries.push({
                id: 0,
                labels: [''],
                parentId: -1
            });
        }
        Array.from(markers.entries()).forEach(value => {
            const categoryName = value[0];
            const rowId = categories.indexOf(categoryName) + 1;
            annotationEntries.push({
                id: rowId,
                labels: [categoryName],
                parentId: 0
            });
            const row = {
                id: rowId,
                name: '',
                range: {
                    start: this.props.viewRange.getStart(),
                    end: this.props.viewRange.getStart() + this.props.unitController.absoluteRange
                },
                states: value[1],
                annotations: [],
                prevPossibleState: BigInt(Number.MIN_SAFE_INTEGER),
                nextPossibleState: BigInt(Number.MAX_SAFE_INTEGER)
            };
            rows.push(row);
        });
        const markerLayerData = {
            rows,
            range: newRange,
            resolution: newResolution
        };
        this.setState({ markerCategoryEntries: annotationEntries, markerLayerData: markerLayerData });
    }
    getMarkersRowIds() {
        const rows = this.state.collapsedMarkerNodes.length !== 0 || !!!this.state.markerLayerData
            ? []
            : this.state.markerLayerData.rows;
        const rowIds = [];
        rows.forEach(row => {
            rowIds.push(row.id);
        });
        return {
            rowIds
        };
    }
    async fetchMarkersData(range, resolution) {
        if (this.state.collapsedMarkerNodes.length !== 0 || !!!this.state.markerLayerData) {
            return {
                rows: [],
                range,
                resolution
            };
        }
        return this.state.markerLayerData;
    }
    getRowStyle(row) {
        let backgroundColor = 0x979797;
        if (row === null || row === void 0 ? void 0 : row.selected) {
            const colorString = getComputedStyle(document.body).getPropertyValue('--trace-viewer-selection-background');
            const colorNumber = (0, convert_color_string_to_hex_1.convertColorStringToHexNumber)(colorString);
            backgroundColor = colorNumber > 0 ? colorNumber : backgroundColor;
        }
        return {
            backgroundColor,
            backgroundOpacity: (row === null || row === void 0 ? void 0 : row.selected) ? 0.5 : 0,
            lineColor: this.props.backgroundTheme === 'light' ? 0xd3d3d3 : 0x3f4146,
            lineThickness: 1
        };
    }
    doHandleContextMenuContributed(payload) {
        if (payload.getOutputDescriptorId() === this.props.outputDescriptor.id) {
            const currentMenuItems = this.state.menuItems
                ? this.state.menuItems
                : { items: [], submenus: [] };
            const menuItemsToAdd = payload.getMenuItems();
            if (currentMenuItems) {
                for (const submenu of menuItemsToAdd.submenus) {
                    // Only add menu entries with unique ids
                    if (currentMenuItems.submenus.findIndex(menu => menu.id === submenu.id) === -1) {
                        currentMenuItems.submenus.push(submenu);
                    }
                }
                for (const menuItem of menuItemsToAdd.items) {
                    if (currentMenuItems.items.findIndex(item => item.id === menuItem.id) === -1) {
                        currentMenuItems.items.push(menuItem);
                    }
                }
            }
            this.setState({ menuItems: currentMenuItems });
        }
    }
    getMarkerStateStyle(state) {
        if (state.data && state.data.annotation) {
            const annotation = state.data.annotation;
            const style = this.getAnnotationStyle(annotation);
            return {
                color: style ? style.color : 0x000000,
                height: this.markerRowController.rowHeight,
                borderWidth: 1,
                borderColor: 0x000000
            };
        }
        return this.getStateStyle(state);
    }
    getStateStyle(state) {
        const styleModel = this.state.styleModel;
        if (styleModel) {
            const metadata = state.data;
            if (metadata && metadata.style) {
                const elementStyle = metadata.style;
                const backgroundColor = this.styleProvider.getColorStyle(elementStyle, style_properties_1.StyleProperties.BACKGROUND_COLOR);
                const heightFactor = this.styleProvider.getNumberStyle(elementStyle, style_properties_1.StyleProperties.HEIGHT);
                let height = this.props.style.rowHeight * 0.8;
                if (heightFactor) {
                    height = heightFactor * height;
                }
                const borderStyle = this.styleProvider.getStyle(elementStyle, style_properties_1.StyleProperties.BORDER_STYLE);
                let borderColor = undefined;
                let borderWidth = undefined;
                if (borderStyle && borderStyle !== 'none') {
                    borderColor = this.styleProvider.getColorStyle(elementStyle, style_properties_1.StyleProperties.BORDER_COLOR);
                    if (borderColor === undefined) {
                        borderColor = { color: 0x000000, alpha: 1 };
                    }
                    borderWidth = this.styleProvider.getNumberStyle(elementStyle, style_properties_1.StyleProperties.BORDER_WIDTH);
                    if (borderWidth === undefined) {
                        borderWidth = 1;
                    }
                }
                return {
                    color: backgroundColor ? backgroundColor.color : 0x000000,
                    opacity: metadata.tags && metadata.tags === 1 ? 0.3 : backgroundColor ? backgroundColor.alpha : 1.0,
                    height: height,
                    borderWidth: state.selected ? 2 : borderWidth ? borderWidth : 0,
                    borderColor: state.selected ? 0xeef20c : borderColor ? borderColor.color : 0x000000
                };
            }
            return undefined;
        }
        return this.getDefaultStateStyle(state);
    }
    getDefaultStateStyle(state) {
        var _a;
        const styleProvider = new style_provider_1.StyleProvider(this.props.outputDescriptor.id, this.props.traceId, this.props.tspClient);
        const styles = styleProvider.getStylesTmp();
        const backupStyles = [
            {
                color: 0x3891a6,
                height: this.props.style.rowHeight * 0.8
            },
            {
                color: 0x4c5b5c,
                height: this.props.style.rowHeight * 0.7
            },
            {
                color: 0xfde74c,
                height: this.props.style.rowHeight * 0.6
            },
            {
                color: 0xdb5461,
                height: this.props.style.rowHeight * 0.5
            },
            {
                color: 0xe3655b,
                height: this.props.style.rowHeight * 0.4
            },
            {
                color: 0xea8f87,
                height: this.props.style.rowHeight * 0.9
            },
            {
                color: 0xde636f,
                height: this.props.style.rowHeight * 0.3
            }
        ];
        let style = backupStyles[0];
        const val = (_a = state.label) !== null && _a !== void 0 ? _a : '';
        const modelData = state.data;
        if (modelData) {
            const outputStyle = modelData.style;
            if (!outputStyle) {
                return {
                    color: 0xcacaca,
                    height: this.props.style.rowHeight * 0.5,
                    borderWidth: state.selected ? 2 : 0,
                    borderColor: 0xeef20c
                };
            }
            const stateStyle = outputStyle;
            const elementStyle = styles[stateStyle.parentKey];
            if (elementStyle) {
                return {
                    color: parseInt(elementStyle.color, 16),
                    height: this.props.style.rowHeight * elementStyle.height,
                    borderWidth: state.selected ? 2 : 0,
                    borderColor: 0xeef20c
                };
            }
            style = this.styleMap.get(stateStyle.parentKey);
            if (style === undefined) {
                style = backupStyles[Math.abs((0, value_hash_1.default)(stateStyle.parentKey)) % backupStyles.length];
                this.styleMap.set(stateStyle.parentKey, style);
            }
            return {
                color: style.color,
                height: style.height,
                borderWidth: state.selected ? 2 : 0,
                borderColor: 0xeef20c
            };
        }
        style = this.styleMap.get(val);
        if (!style) {
            style = backupStyles[this.styleMap.size % backupStyles.length];
            this.styleMap.set(val, style);
        }
        return {
            color: style.color,
            height: style.height,
            borderWidth: state.selected ? 2 : 0,
            borderColor: 0xeef20c
        };
    }
    getAnnotationStyle(annotation) {
        const styleModel = this.state.styleModel;
        if (styleModel) {
            const metadata = annotation.data;
            if (metadata && metadata.style) {
                const elementStyle = metadata.style;
                const symbolType = this.styleProvider.getStyle(elementStyle, style_properties_1.StyleProperties.SYMBOL_TYPE);
                const color = this.styleProvider.getColorStyle(elementStyle, style_properties_1.StyleProperties.COLOR);
                const heightFactor = this.styleProvider.getNumberStyle(elementStyle, style_properties_1.StyleProperties.HEIGHT);
                let symbolSize = (this.props.style.rowHeight * 0.8) / 2;
                if (heightFactor) {
                    symbolSize = heightFactor * symbolSize;
                }
                const vAlign = this.styleProvider.getStyle(elementStyle, style_properties_1.StyleProperties.VERTICAL_ALIGN);
                return {
                    symbol: symbolType ? symbolType : 'none',
                    size: symbolSize,
                    color: color ? color.color : 0x000000,
                    opacity: color ? color.alpha : 1.0,
                    verticalAlign: vAlign ? vAlign : 'middle'
                };
            }
        }
        return undefined;
    }
    expandParents(entry) {
        let foundNode = this.state.timegraphTree.find(node => node.id === (entry === null || entry === void 0 ? void 0 : entry.id));
        if (foundNode) {
            let parentId = foundNode.parentId;
            const ids = [];
            while (parentId && parentId >= 0) {
                ids.push(parentId);
                foundNode = this.state.timegraphTree.find(node => node.id === parentId);
                parentId = foundNode === null || foundNode === void 0 ? void 0 : foundNode.parentId;
            }
            let newList = [...this.state.collapsedNodes];
            ids.forEach(parentIds => {
                const exist = this.state.collapsedNodes.find(expandId => expandId === parentIds);
                if (exist !== undefined) {
                    newList = newList.filter(collapsed => parentIds !== collapsed);
                }
            });
            const retVal = newList.length === this.state.collapsedNodes.length;
            this.setState({ collapsedNodes: newList }, this.updateTotalHeight);
            return retVal;
        }
    }
    selectAndReveal(item) {
        const rowIndex = (0, utils_1.getIndexOfNode)(item.id, (0, utils_1.listToTree)(this.state.timegraphTree, this.state.columns), this.state.collapsedNodes);
        this.chartLayer.selectAndReveal(rowIndex);
    }
}
exports.TimegraphOutputComponent = TimegraphOutputComponent;
//# sourceMappingURL=timegraph-output-component.js.map