import * as React from 'react';
import { SortConfig } from './sort';
import ColumnHeader from './column-header';
interface TableHeaderProps {
    columns: ColumnHeader[];
    sortableColumns: string[];
    sortConfig: SortConfig[];
    onSort: (sortColumn: string) => void;
}
export declare class TableHeader extends React.Component<TableHeaderProps> {
    private mouseDownX;
    private originalWidth;
    private resizedHeader;
    private resizedIndex;
    private gridTemplateColumns;
    constructor(props: TableHeaderProps);
    handleSortChange: (sortColumn: string, ev: React.MouseEvent<HTMLTableCellElement, MouseEvent>) => void;
    handleResizeDoubleClick: (ev: React.MouseEvent<HTMLSpanElement, MouseEvent>, index: number) => void;
    handleResizeMouseDown: (ev: React.MouseEvent<HTMLSpanElement, MouseEvent>, index: number) => void;
    handleResizeMouseMove: (ev: MouseEvent) => void;
    handleResizeMouseUp: () => void;
    toHeaderTitle: (name: string) => string;
    renderSortIcon: (column: string) => React.ReactNode | undefined;
    renderResizeIcon: (index: number) => React.ReactNode;
    renderHeader: () => React.ReactNode;
    render(): React.ReactNode;
}
export {};
//# sourceMappingURL=table-header.d.ts.map