import * as React from 'react';
export interface ReactTimeRangeDataWidgetProps {
    id: string;
    title: string;
}
export interface ReactTimeRangeDataWidgetState {
    activeData?: ExperimentTimeRangeData;
    userInputSelectionStartIsValid: boolean;
    userInputSelectionEndIsValid: boolean;
    userInputSelectionStart?: string;
    userInputSelectionEnd?: string;
    inputting: boolean;
}
export interface ExperimentTimeRangeData {
    UUID: string;
    absoluteRange?: {
        start: bigint;
        end: bigint;
    };
    viewRange?: {
        start: bigint;
        end: bigint;
    };
    selectionRange?: {
        start: bigint;
        end: bigint;
    };
}
export declare class ReactTimeRangeDataWidget extends React.Component<ReactTimeRangeDataWidgetProps, ReactTimeRangeDataWidgetState> {
    private experimentDataMap;
    constructor(props: ReactTimeRangeDataWidgetProps);
    private subscribeToEvents;
    componentWillUnmount: () => void;
    private onViewRangeUpdated;
    private onSelectionRangeUpdated;
    private onAbsoluteRangeUpdate;
    private onExperimentUpdated;
    private onExperimentSelected;
    private onExperimentClosed;
    private setActiveExperiment;
    private renderIfActive;
    restoreData: (mapArray: Array<ExperimentTimeRangeData>, activeData: ExperimentTimeRangeData) => void;
    private reset;
    private onChange;
    private onSubmit;
    /**
     *
     * Sometimes the unitController's selection range has a start that's larger than the end (they're reversed).
     * This always sets the lesser number as the start.
     * @param value1
     * @param value2
     * @returns { start: string, end: string }
     */
    private getStartAndEnd;
    private verifyUserInput;
    render(): React.ReactNode;
}
//# sourceMappingURL=trace-explorer-time-range-data-widget.d.ts.map